package org.cometd.javascript.jquery;

import java.util.Arrays;
import java.util.List;

import org.cometd.javascript.Latch;

/**
 * @version $Revision: 1389 $ $Date: 2010-07-12 14:46:01 +0200 (Mon, 12 Jul 2010) $
 */
public class CometdPublishHeldUntilHandshookTest extends AbstractCometdJQueryTest
{
    public void testPublishHeldUntilHandshook() throws Exception
    {
        defineClass(Latch.class);
        evaluateScript("" +
                "$.cometd.configure({url: '" + cometdURL + "', logLevel: 'debug'});" +
                "var latch = new Latch(2);" +
                "var savedChannels;" +
                "var channels = [];" +
                "$.cometd.registerExtension('test', {" +
                "    outgoing: function(message) " +
                "    {" +
                "        channels.push(message.channel);" +
                "    }" +
                "});" +
                "$.cometd.addListener('/meta/handshake', function(message)" +
                "{" +
                "    $.cometd.publish('/bar', {});" +
                "    $.cometd.batch(function()" +
                "    {" +
                "        $.cometd.subscribe('/foo', function(msg) { latch.countDown(); });" +
                "        $.cometd.publish('/foo', {});" +
                "    });" +
                "});" +
                "$.cometd.addListener('/meta/connect', function(message)" +
                "{" +
                "   /* Copy the array so that from now on it is not modified anymore */" +
                "   if (!savedChannels)" +
                "   {" +
                "       savedChannels = channels.slice(0);" +
                "       latch.countDown();" +
                "   }" +
                "});" +
                "");
        Latch latch = (Latch)get("latch");
        evaluateScript("$.cometd.handshake();");

        assertTrue(latch.await(1000));

        Object jsChannels = get("savedChannels");
        Object[] channels = (Object[])jsToJava(jsChannels);
        assertNotNull(channels);
        List<Object> expectedChannels = Arrays.<Object>asList("/meta/handshake", "/bar", "/meta/subscribe", "/foo", "/meta/connect");
        assertEquals(expectedChannels, Arrays.asList(channels));

        evaluateScript("$.cometd.disconnect(true);");
    }
}
